(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs/operators'), require('rxjs'), require('@swimlane/ngx-datatable'), require('@ngx-translate/core'), require('@angular/forms'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-datatable-footer', ['exports', '@angular/core', 'rxjs/operators', 'rxjs', '@swimlane/ngx-datatable', '@ngx-translate/core', '@angular/forms', '@angular/common'], factory) :
    (global = global || self, factory(global['ngx-datatable-footer'] = {}, global.ng.core, global.rxjs.operators, global.rxjs, global.ngxDatatable, global.core$1, global.ng.forms, global.ng.common));
}(this, (function (exports, core, operators, rxjs, ngxDatatable, core$1, forms, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    var DatatablePagerComponent = /** @class */ (function () {
        function DatatablePagerComponent() {
            this.linage = true;
            this.displayBothEnds = true;
            this.pageNumber = true;
            this.pageJumpTime = 1000;
            this.change = new core.EventEmitter();
            this.pageChange = new core.EventEmitter();
            this.maxPage = new core.EventEmitter();
            this.pageSizeColumn = true;
            this._page = 1;
            this._count = 0;
            this._size = 0;
        }
        Object.defineProperty(DatatablePagerComponent.prototype, "size", {
            get: function () {
                return this._size;
            },
            set: function (val) {
                this._size = val;
                this.pages = this.calcPages();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DatatablePagerComponent.prototype, "count", {
            get: function () {
                return this._count;
            },
            set: function (val) {
                this._count = val;
                this.pages = this.calcPages();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DatatablePagerComponent.prototype, "page", {
            get: function () {
                return this._page;
            },
            set: function (val) {
                if (val) {
                    this._page = val;
                    this.pages = this.calcPages();
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DatatablePagerComponent.prototype, "totalPages", {
            get: function () {
                var count = this.size < 1 ? 1 : Math.ceil(this.count / this.size);
                return Math.max(count || 0, 1);
            },
            enumerable: true,
            configurable: true
        });
        DatatablePagerComponent.prototype.ngOnInit = function () { };
        DatatablePagerComponent.prototype.ngAfterViewInit = function () {
            var _this = this;
            this.inputEvent = rxjs.fromEvent(this.customerInput.nativeElement, 'input')
                .pipe(operators.debounceTime(this.pageJumpTime))
                .subscribe(function (event) {
                var value;
                if (event.target.value) {
                    value = Number(event.target.value);
                    if (value < 1) {
                        value = 1;
                        _this.customerInput.nativeElement.value = 1;
                    }
                    else if (value > _this.totalPages) {
                        value = _this.totalPages;
                        _this.customerInput.nativeElement.value = _this.totalPages;
                        _this.maxPage.emit(_this.totalPages);
                    }
                    _this.page = value;
                    _this.selectPage(Math.round(value));
                }
            });
        };
        DatatablePagerComponent.prototype.canPrevious = function () {
            return this.page > 1;
        };
        DatatablePagerComponent.prototype.canNext = function () {
            return this.page < this.totalPages;
        };
        DatatablePagerComponent.prototype.prevPage = function () {
            this.selectPage(this.page - 1);
        };
        DatatablePagerComponent.prototype.nextPage = function () {
            this.selectPage(this.page + 1);
        };
        DatatablePagerComponent.prototype.firstPage = function () {
            if (this.canPrevious()) {
                this.selectPage(1);
            }
        };
        DatatablePagerComponent.prototype.lastPage = function () {
            if (this.canNext()) {
                this.selectPage(this.totalPages);
            }
        };
        DatatablePagerComponent.prototype.selectPage = function (page, changePageSize) {
            if (changePageSize) {
                if (page > 0 && page <= this.totalPages) {
                    this.page = page;
                    this.currentOffset = page;
                    this.change.emit({ page: page });
                }
            }
            else {
                if (page > 0 && page <= this.totalPages) {
                    this.page = page;
                    this.currentOffset = page;
                    this.change.emit({ page: page });
                }
            }
        };
        DatatablePagerComponent.prototype.calcPages = function (page) {
            var pages = [];
            var startPage = 1;
            var endPage = this.totalPages;
            var maxSize = 5;
            var isMaxSized = maxSize < this.totalPages;
            page = page || this.page;
            if (isMaxSized) {
                startPage = (Math.ceil(page / maxSize) - 1) * maxSize + 1;
                endPage = Math.min(startPage + maxSize - 1, this.totalPages);
            }
            for (var num = startPage; num <= endPage; num++) {
                pages.push({ number: num, text: num });
            }
            return pages;
        };
        DatatablePagerComponent.prototype.blurHandel = function () {
            this.customerInput.nativeElement.value = this.page;
        };
        DatatablePagerComponent.prototype.changePageSize = function (pageSize) {
            this.datatable.limit = pageSize;
            this.selectPage(1, 'changePageSize');
        };
        DatatablePagerComponent.prototype.keyDownHandel = function (event) {
            if (this.customerInput.nativeElement.value) {
                this.prveOffset = Number(this.customerInput.nativeElement.value);
            }
            if ((event.keyCode < 48 && event.keyCode !== 8) ||
                (event.keyCode > 57 && event.keyCode < 96) ||
                event.keyCode > 105) {
                return false;
            }
        };
        DatatablePagerComponent.prototype.ngOnDestroy = function () {
            this.inputEvent.unsubscribe();
        };
        __decorate([
            core.Input(),
            __metadata("design:type", String)
        ], DatatablePagerComponent.prototype, "pagerLeftArrowIcon", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", String)
        ], DatatablePagerComponent.prototype, "pagerRightArrowIcon", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", String)
        ], DatatablePagerComponent.prototype, "pagerPreviousIcon", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", String)
        ], DatatablePagerComponent.prototype, "pagerNextIcon", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", Array)
        ], DatatablePagerComponent.prototype, "pageSizes", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", Object)
        ], DatatablePagerComponent.prototype, "datatable", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", Boolean)
        ], DatatablePagerComponent.prototype, "linage", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", Boolean)
        ], DatatablePagerComponent.prototype, "displayBothEnds", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", Boolean)
        ], DatatablePagerComponent.prototype, "pageNumber", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", Number)
        ], DatatablePagerComponent.prototype, "pageJumpTime", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", Object)
        ], DatatablePagerComponent.prototype, "labels", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", Number),
            __metadata("design:paramtypes", [Number])
        ], DatatablePagerComponent.prototype, "size", null);
        __decorate([
            core.Input(),
            __metadata("design:type", Number),
            __metadata("design:paramtypes", [Number])
        ], DatatablePagerComponent.prototype, "count", null);
        __decorate([
            core.Input(),
            __metadata("design:type", Number),
            __metadata("design:paramtypes", [Number])
        ], DatatablePagerComponent.prototype, "page", null);
        __decorate([
            core.Output(),
            __metadata("design:type", core.EventEmitter)
        ], DatatablePagerComponent.prototype, "change", void 0);
        __decorate([
            core.Output(),
            __metadata("design:type", core.EventEmitter)
        ], DatatablePagerComponent.prototype, "pageChange", void 0);
        __decorate([
            core.Output(),
            __metadata("design:type", core.EventEmitter)
        ], DatatablePagerComponent.prototype, "maxPage", void 0);
        __decorate([
            core.ViewChild('customerInput', { static: true }),
            __metadata("design:type", core.ElementRef)
        ], DatatablePagerComponent.prototype, "customerInput", void 0);
        DatatablePagerComponent = __decorate([
            core.Component({
                selector: 'app-datatable-pager',
                template: " <ul class=\"pager\">\n    <li\n      class=\"page-size-continer\"\n      *ngIf=\"linage\"\n      (click)=\"pageSizeColumn = !pageSizeColumn\"\n      (mouseleave)=\"pageSizeColumn = true\"\n    >\n      <span>{{ size }} {{ labels.line }}/{{ labels.page }}</span>\n      <span\n        class=\"fa\"\n        [ngClass]=\"{\n          'fa-angle-up': pageSizeColumn,\n          'fa-angle-down': !pageSizeColumn\n        }\"\n      ></span>\n      <ul [hidden]=\"pageSizeColumn\" class=\"page-size-content\">\n        <li\n          *ngFor=\"let ps of pageSizes\"\n          (click)=\"changePageSize(ps)\"\n          [ngClass]=\"{ 'page-size-column-active': size === ps }\"\n        >\n          {{ ps }} {{ labels.line }}/{{ labels.page }}\n        </li>\n      </ul>\n    </li>\n    <li *ngIf=\"displayBothEnds\" [class.disabled]=\"!canPrevious()\">\n      <a (click)=\"firstPage()\">\n        <i class=\"{{ pagerPreviousIcon }}\"></i>\n      </a>\n    </li>\n    <li [class.disabled]=\"!canPrevious()\">\n      <a (click)=\"prevPage()\">\n        <i class=\"{{ pagerLeftArrowIcon }}\"></i>\n      </a>\n    </li>\n    <li class=\"pages\" *ngFor=\"let pg of pages\" [class.active]=\"pg.number === page\">\n      <a *ngIf=\"pageNumber\" (click)=\"selectPage(pg.number)\">\n        {{ pg.text }}\n      </a>\n    </li>\n    <li [class.disabled]=\"!canNext()\">\n      <a (click)=\"nextPage()\">\n        <i class=\"{{ pagerRightArrowIcon }}\"></i>\n      </a>\n    </li>\n    <li *ngIf=\"displayBothEnds\" [class.disabled]=\"!canNext()\">\n      <a (click)=\"lastPage()\">\n        <i class=\"{{ pagerNextIcon }}\"></i>\n      </a>\n    </li>\n    <li [ngStyle]=\"{ position: 'relative' }\">\n      <span>{{ labels.jumpTo }}</span>\n      <input\n        #customerInput\n        class=\"lz-jump-page\"\n        type=\"number\"\n        title=\" \"\n        rows=\"2\"\n        [min]=\"1\"\n        [ngModel]=\"page\"\n        (keydown)=\"keyDownHandel($event)\"\n        (blur)=\"blurHandel()\"\n      />{{ labels.page }}\n    </li>\n  </ul>",
                styles: ["\n      .page-size-continer {\n        position: relative;\n        min-width: 80px;\n        height: 26px;\n        line-height: 26px;\n        text-align: center;\n        border-radius: 2px;\n        cursor: pointer;\n        padding: 0 10px !important;\n      }\n      .page-size-continer:hover {\n        background-color: rgba(158, 158, 158, 0.2);\n      }\n      .page-size-continer .page-size-content {\n        position: absolute;\n        bottom: 24px;\n        left: 0;\n        padding: 0;\n        background: #fff;\n        border-radius: 4px;\n        box-shadow: 0 0 15px 1px rgba(113, 106, 202, 0.2);\n        z-index: 11;\n      }\n      .page-size-continer .page-size-content li {\n        width: 100%;\n        padding: 4px 0;\n      }\n      .page-size-continer .page-size-content li:hover {\n        background-color: rgba(158, 158, 158, 0.2);\n      }\n      .page-size-continer .page-size-content .page-size-column-active {\n        color: #409eff;\n      }\n      input[type='number']::-webkit-inner-spin-button,\n      input[type='number']::-webkit-outer-spin-button {\n        -webkit-appearance: none;\n      }\n      .lz-jump-page {\n        display: inline-block;\n        width: 50px;\n        border-radius: 2px;\n        margin-right: 6px;\n        padding-left: 4px;\n        border: solid 1px #ebedf2;\n      }\n      input[type='number'] {\n        -moz-appearance: textfield;\n      }\n    "]
            })
        ], DatatablePagerComponent);
        return DatatablePagerComponent;
    }());

    var Ngx_Datatable_Footer_Option = new core.InjectionToken('Ngx_Datatable_Footer_Option');
    function FooterOptionProvider(options) {
        if (options === void 0) { options = {}; }
        return {
            provide: Ngx_Datatable_Footer_Option,
            useValue: options
        };
    }

    var FooterConfigurationService = /** @class */ (function () {
        function FooterConfigurationService(footerOptions, translate) {
            var _this = this;
            this.footerOptions = footerOptions;
            this.translate = translate;
            this.defaultLabels = {
                current: '当前 ',
                line: '行',
                page: '页',
                jumpTo: '跳转到',
            };
            this._subs = new rxjs.Subscription();
            this.update();
            this._subs.add(this.translate.onLangChange.subscribe(function (lang) {
                setTimeout(function () {
                    _this.update();
                }, 0);
            }));
        }
        FooterConfigurationService.prototype.ngOnDestroy = function () {
            this._subs.unsubscribe();
        };
        FooterConfigurationService.prototype.update = function () {
            var _this = this;
            this._language = localStorage.getItem('lang');
            if (this._language === 'zh-CN' || !this._language) {
                this.labels = this.defaultLabels;
            }
            else {
                if (this._language) {
                    if (this._language) {
                        this._subs.add(this.translate.get('ngxFooterSettings.labels').subscribe(function (translations) {
                            _this.labels = translations;
                        }));
                    }
                }
            }
        };
        FooterConfigurationService.ctorParameters = function () { return [
            { type: undefined, decorators: [{ type: core.Optional }, { type: core.Inject, args: [Ngx_Datatable_Footer_Option,] }] },
            { type: core$1.TranslateService }
        ]; };
        FooterConfigurationService = __decorate([
            core.Injectable(),
            __param(0, core.Optional()), __param(0, core.Inject(Ngx_Datatable_Footer_Option)),
            __metadata("design:paramtypes", [Object, core$1.TranslateService])
        ], FooterConfigurationService);
        return FooterConfigurationService;
    }());

    function provideParent(component, parentType) {
        return { provide: parentType, useExisting: core.forwardRef(function () { return component; }) };
    }
    var DatatableFooterComponent = /** @class */ (function () {
        function DatatableFooterComponent(config, componentFactoryResolver, viewContainerRef) {
            this.config = config;
            this.componentFactoryResolver = componentFactoryResolver;
            this.viewContainerRef = viewContainerRef;
            this.pagerLeftArrowIcon = 'fa fa-angle-left';
            this.pagerRightArrowIcon = 'fa fa-angle-right';
            this.pagerPreviousIcon = 'fa fa-step-backward';
            this.pagerNextIcon = 'fa fa-step-forward';
            this.pageSizes = [10, 20, 30, 40, 50];
            this.totalNumber = true;
            this.linage = true;
            this.displayBothEnds = true;
            this.pageNumber = true;
            this.pageJumpTime = 1000;
            this.pageChange = new core.EventEmitter();
            this.maxPage = new core.EventEmitter();
        }
        DatatableFooterComponent_1 = DatatableFooterComponent;
        Object.defineProperty(DatatableFooterComponent.prototype, "template", {
            get: function () {
                return this._templateInput || this._templateQueryDefault || this._templateQuery;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DatatableFooterComponent.prototype, "datatable", {
            get: function () {
                return this._datatable;
            },
            set: function (val) {
                this._datatable = val;
            },
            enumerable: true,
            configurable: true
        });
        DatatableFooterComponent.prototype.ngOnInit = function () {
            if (this.config.footerOptions && this.config.footerOptions.pageStatics) {
                var componentFactory = this.componentFactoryResolver.resolveComponentFactory(this.config.footerOptions.pageStatics);
                // 因为默认创建组件时，获取不到组件的templateRef,所以改用这种方式
                this._pageStaticsComponentRef = this.viewContainerRef.createComponent(componentFactory);
            }
        };
        DatatableFooterComponent.prototype.ngAfterViewInit = function () {
            if (this._pageStaticsComponentRef) {
                this.pageStaticsTemplateRef = this._pageStaticsComponentRef.instance.templateRef;
                // 先移除，目前看不移除也不会造成内存问题
                this.viewContainerRef.remove(this.viewContainerRef.indexOf(this._pageStaticsComponentRef.hostView));
                this._pageStaticsComponentRef.destroy();
            }
        };
        DatatableFooterComponent.prototype.onFooterPage = function (event) {
            if (typeof event.page === 'number') {
                this.datatable.onFooterPage(event);
            }
        };
        DatatableFooterComponent.prototype.emitPage = function (event) {
            if (typeof event.page === 'number') {
                this.pageChange.emit(event);
            }
        };
        DatatableFooterComponent.prototype.emitMaxPage = function (page) {
            this.maxPage.emit(page);
        };
        var DatatableFooterComponent_1;
        DatatableFooterComponent.ctorParameters = function () { return [
            { type: FooterConfigurationService },
            { type: core.ComponentFactoryResolver },
            { type: core.ViewContainerRef }
        ]; };
        __decorate([
            core.Input(),
            __metadata("design:type", String)
        ], DatatableFooterComponent.prototype, "pagerLeftArrowIcon", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", String)
        ], DatatableFooterComponent.prototype, "pagerRightArrowIcon", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", String)
        ], DatatableFooterComponent.prototype, "pagerPreviousIcon", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", String)
        ], DatatableFooterComponent.prototype, "pagerNextIcon", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", Array)
        ], DatatableFooterComponent.prototype, "pageSizes", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", Boolean)
        ], DatatableFooterComponent.prototype, "totalNumber", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", Boolean)
        ], DatatableFooterComponent.prototype, "linage", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", Boolean)
        ], DatatableFooterComponent.prototype, "displayBothEnds", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", Boolean)
        ], DatatableFooterComponent.prototype, "pageNumber", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", Number)
        ], DatatableFooterComponent.prototype, "page", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", Number)
        ], DatatableFooterComponent.prototype, "pageJumpTime", void 0);
        __decorate([
            core.Output(),
            __metadata("design:type", Object)
        ], DatatableFooterComponent.prototype, "pageChange", void 0);
        __decorate([
            core.Output(),
            __metadata("design:type", Object)
        ], DatatableFooterComponent.prototype, "maxPage", void 0);
        __decorate([
            core.Input('template'),
            __metadata("design:type", core.TemplateRef)
        ], DatatableFooterComponent.prototype, "_templateInput", void 0);
        __decorate([
            core.ViewChild(ngxDatatable.DataTableFooterTemplateDirective, { static: true, read: core.TemplateRef }),
            __metadata("design:type", core.TemplateRef)
        ], DatatableFooterComponent.prototype, "_templateQuery", void 0);
        __decorate([
            core.ContentChild(ngxDatatable.DataTableFooterTemplateDirective, { static: true, read: core.TemplateRef }),
            __metadata("design:type", core.TemplateRef)
        ], DatatableFooterComponent.prototype, "_templateQueryDefault", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", ngxDatatable.DatatableComponent),
            __metadata("design:paramtypes", [ngxDatatable.DatatableComponent])
        ], DatatableFooterComponent.prototype, "datatable", null);
        DatatableFooterComponent = DatatableFooterComponent_1 = __decorate([
            core.Component({
                selector: 'zr-ngx-datatable-footer,ngx-datatable-footer',
                template: "<ng-template\n  ngx-datatable-footer-template\n  let-rowCount=\"rowCount\"\n  let-pageSize=\"pageSize\"\n  let-selectedCount=\"selectedCount\"\n  let-curPage=\"curPage\"\n  let-offset=\"offset\"\n>\n  <div\n    class=\"page-count\"\n    *ngIf=\"!pageStaticsTemplateRef && rowCount > 0 && totalNumber\"\n    [innerHTML]=\"\n      config.labels.current +\n      ((offset || 0) * pageSize + 1) +\n      ' - ' +\n      ((offset + 1) * pageSize > rowCount ? rowCount : (offset + 1 || 1) * pageSize) +\n      ' / ' +\n      rowCount +\n      config.labels.line\n    \"\n  ></div>\n\n  <ng-container\n    *ngIf=\"pageStaticsTemplateRef\"\n    [ngTemplateOutlet]=\"pageStaticsTemplateRef\"\n    [ngTemplateOutletContext]=\"{\n      rowCount: rowCount,\n      pageSize: pageSize,\n      selectedCount: selectedCount,\n      curPage: curPage,\n      offset: offset,\n      config: config\n    }\"\n  ></ng-container>\n\n  <app-datatable-pager\n    *ngIf=\"rowCount > 0\"\n    [displayBothEnds]=\"displayBothEnds\"\n    [pageNumber]=\"pageNumber\"\n    [pageSizes]=\"pageSizes\"\n    [pagerPreviousIcon]=\"pagerPreviousIcon\"\n    [pagerNextIcon]=\"pagerNextIcon\"\n    [pagerLeftArrowIcon]=\"pagerLeftArrowIcon\"\n    [pagerRightArrowIcon]=\"pagerRightArrowIcon\"\n    [page]=\"curPage\"\n    [size]=\"pageSize\"\n    [pageJumpTime]=\"pageJumpTime\"\n    [datatable]=\"datatable\"\n    [count]=\"rowCount\"\n    [labels]=\"config.labels\"\n    (change)=\"onFooterPage($event); emitPage($event)\"\n    (pageChange)=\"emitPage($event)\"\n    (maxPage)=\"emitMaxPage($event)\"\n    class=\"datatable-pager\"\n  ></app-datatable-pager>\n</ng-template>\n",
                providers: [provideParent(DatatableFooterComponent_1, ngxDatatable.DatatableFooterDirective)]
            }),
            __metadata("design:paramtypes", [FooterConfigurationService,
                core.ComponentFactoryResolver,
                core.ViewContainerRef])
        ], DatatableFooterComponent);
        return DatatableFooterComponent;
    }());

    var NgxDatatableFooterModule = /** @class */ (function () {
        function NgxDatatableFooterModule() {
        }
        NgxDatatableFooterModule_1 = NgxDatatableFooterModule;
        NgxDatatableFooterModule.forRoot = function (footerOptions) {
            return {
                ngModule: NgxDatatableFooterModule_1,
                providers: [FooterOptionProvider(footerOptions)],
            };
        };
        var NgxDatatableFooterModule_1;
        NgxDatatableFooterModule = NgxDatatableFooterModule_1 = __decorate([
            core.NgModule({
                imports: [common.CommonModule, forms.FormsModule, core$1.TranslateModule, ngxDatatable.NgxDatatableModule],
                declarations: [DatatablePagerComponent, DatatableFooterComponent],
                exports: [DatatablePagerComponent, DatatableFooterComponent],
                providers: [FooterConfigurationService],
            })
        ], NgxDatatableFooterModule);
        return NgxDatatableFooterModule;
    }());

    exports.DatatableFooterComponent = DatatableFooterComponent;
    exports.DatatablePagerComponent = DatatablePagerComponent;
    exports.FooterConfigurationService = FooterConfigurationService;
    exports.FooterOptionProvider = FooterOptionProvider;
    exports.NgxDatatableFooterModule = NgxDatatableFooterModule;
    exports.Ngx_Datatable_Footer_Option = Ngx_Datatable_Footer_Option;
    exports.provideParent = provideParent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-datatable-footer.umd.js.map
