import { OnInit, EventEmitter, AfterViewInit, ElementRef, OnDestroy } from '@angular/core';
import { Subscription } from 'rxjs';
export declare class DatatablePagerComponent implements OnInit, AfterViewInit, OnDestroy {
    pagerLeftArrowIcon: string;
    pagerRightArrowIcon: string;
    pagerPreviousIcon: string;
    pagerNextIcon: string;
    pageSizes: any[];
    datatable: any;
    linage?: Boolean;
    displayBothEnds?: Boolean;
    pageNumber?: Boolean;
    pageJumpTime?: number;
    labels: any;
    set size(val: number);
    get size(): number;
    set count(val: number);
    get count(): number;
    set page(val: number);
    get page(): number;
    get totalPages(): number;
    change: EventEmitter<any>;
    pageChange: EventEmitter<any>;
    maxPage: EventEmitter<any>;
    currentOffset: number;
    prveOffset: number;
    inputEvent: Subscription;
    customerInput: ElementRef;
    pages: any;
    pageSizeColumn: boolean;
    _page: number;
    _count: number;
    _size: number;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    canPrevious(): boolean;
    canNext(): boolean;
    prevPage(): void;
    nextPage(): void;
    firstPage(): void;
    lastPage(): void;
    selectPage(page: number, changePageSize?: any): void;
    calcPages(page?: number): any[];
    blurHandel(): void;
    changePageSize(pageSize: number): void;
    keyDownHandel(event: any): boolean;
    ngOnDestroy(): void;
}
